--
--
-- DediSave
--
-- # Author:  Heady
-- # date: 18.02.2015
-- # update LS17: 04.01.2017
-- # update LS19: 31.01.2019
-- # last update: 08.02.2019
--
-- > Not for commercial use  < --
-- > Not allowed for edit - Copyright (C) Heady - www.planet-ls.de < --
--

local modDir = g_currentModDirectory;


local modDescXML = loadXMLFile("modDesc", modDir .. "modDesc.xml");
local version = getXMLString(modDescXML, "modDesc.version");
local descVersion = getXMLString(modDescXML, "modDesc#descVersion");
if modDescXML ~= nil and version ~= nil then
	if descVersion == "42" then
		print("Mod:  DediSave v"..tostring(version).." loaded by Heady - www.planet-ls.de");

		ModEvent = {};

		--[[function ModEvent:loadMap(name)
		end;

		function ModEvent:deleteMap()
		end;

		function ModEvent:mouseEvent(posX, posY, isDown, isUp, button)
		end;

		function ModEvent:keyEvent(unicode, sym, modifier, isDown)
		end;

		function ModEvent:update(dt)
		end;

		function ModEvent:draw()
		end;

		addModEventListener(ModEvent);]]

		function ModEvent:update(dt)

			if g_dedicatedServerInfo ~= nil then
			
				if self.dediSave_canSave == nil then	
					self.dediSave_canSave = false;
					self.dediSave_players = {};
					self.dediSave_g_currentMissionPlayers = {};
					self.dediSave_allowSave = false;
				end;

			
				self.dediSave_g_currentMissionPlayers = {};
				local numPlayers = 0;
				for key, player in pairs(self.players) do
					numPlayers = numPlayers + 1;	
					table.insert(self.dediSave_g_currentMissionPlayers, player);
				end
				
				if numPlayers > 1 then
					self.dediSave_canSave = true;
					if not self.dediSave_allowSave then
						self.dediSave_allowSave = true;
					end;
				end;
				
				if table.getn(self.dediSave_g_currentMissionPlayers) > table.getn(self.players) then		
					for i=1, table.getn(self.dediSave_g_currentMissionPlayers) do
						local playerFound = false;			
						for j=1, table.getn(self.dediSave_players) do
							if self.dediSave_g_currentMissionPlayers[i] == self.dediSave_players[j] then
								playerFound = true;
							end;
						end;
						
						if not playerFound then
							table.insert(self.dediSave_players, self.dediSave_g_currentMissionPlayers[i]);
							print("DediSave: Player "..self.dediSave_g_currentMissionPlayers[i].visualInformation.playerName.." joined - current Player: "..table.getn(self.dediSave_players));
						end;
					end;
					
				end;		
				if table.getn(self.dediSave_g_currentMissionPlayers) < table.getn(self.dediSave_players) then		
					for i=1, table.getn(self.dediSave_players) do
						local playerFound = false;			
						for j=1, table.getn(self.dediSave_g_currentMissionPlayers) do
							if self.dediSave_g_currentMissionPlayers[j] == self.dediSave_players[i] then
								playerFound = true;
							end;
						end;				
						if not playerFound then
							print("DediSave: Player "..self.dediSave_players[i].visualInformation.playerName.." leave - current Player: "..tostring(table.getn(self.dediSave_players)-1));
							table.remove(self.dediSave_players, i);
							break;
						end;
					end;
				end;		
				
				if self.dediSave_canSave and numPlayers < 2 then
					print("DediSave: last Player leave, save current Game");
					self:saveSavegame(self.missionInfo);
					self.dediSave_canSave = false;
					self.dediSave_allowSave = false;
				end;		
		 
			end;

		end;

		local FSBaseMissionSaveSavegame = FSBaseMission.saveSavegame;
		FSBaseMission.saveSavegame = function(self, inst1)
			if self.dediSave_allowSave ~= nil then
				if not self.dediSave_allowSave then
					return;
				end;
			end;
			FSBaseMissionSaveSavegame(self, inst1);
		end;

		BaseMission.update = Utils.prependedFunction(BaseMission.update, ModEvent.update);

	end;
end;